package com.care.installation.service;


import com.care.bms.mqtt.MqttDataConnector;

import com.care.common.entity.CareDevice;
import com.care.common.util.CommonConfUtil;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author: stw
 * @Date: 2021/8/14
 * @Desc:
 */
@Service
public class MqttPublishService {


    /**
     * 初始化mqtt
     */
    private MqttDataConnector init(String cliendId) {
        try {
            MqttDataConnector xbMqttDataConnector = new MqttDataConnector();
            Map<String, String> configParams = new HashMap<>();
            String host = "ws://" + CommonConfUtil.getConf("mqtt.broker") + ":" + CommonConfUtil.getConf("mqtt.port");
            String username = CommonConfUtil.getConf("mqtt.username");
            String password = CommonConfUtil.getConf("mqtt.password");
            configParams.put("MQTT_HOST", host);
            configParams.put("MQTT_CLIENTID", cliendId);
            configParams.put("MQTT_USERNAME", username);
            configParams.put("MQTT_PASSWORD", password);
            xbMqttDataConnector.createIotDataSource(configParams);
            return xbMqttDataConnector;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 发布消息
     */
    public boolean publish(CareDevice careDevice,String data) {
        try {
            String topic = careDevice.getTopic();
            String cliendId = careDevice.getClientId();
            if (StringUtils.isEmpty(topic) || StringUtils.isEmpty(cliendId)) {
                return false;
            }
            String publishTopic = topic.replace("event","control");
            MqttDataConnector mqttDataConnector = init(cliendId);
            if(mqttDataConnector == null){
                return false;
            }
            mqttDataConnector.publish(publishTopic, data);
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

}
